// linux.cpp

#include "jcpplisp.h"

extern CELL *TCell,*NILCell,*CHARACTER,*TINTERNAL;

CELL *cfunction::char_to_code(CELL *p,SYMVAL *loc,long locn,long lock)
{
    CELL *q,*r,*s;
    AINT *i;

    if (p->attr != 'l') goto serror;
    s = p->car;
    IncCellStack(NULL);
    IncCellStack(p);
    q = eval(s,loc,locn,lock);
    PopCellStack();
    if (q == NULL) return NULL;
    if (q->attr != 'm') goto serror;
#if LINUXCOMPILER
    i = (AINT *)getInt(((unsigned long)(q->car)) & 0xff);
#else
    unsigned char a[1];
    a[0] = ((unsigned long)(q->car)) & 0xff;
//printf("%d\n",a[0]);
    if (!isKanji(a)) {
	i = (AINT *)getInt(a[0]);
    }
    else {
	i = (AINT *)getInt(((unsigned long)a[0]) * 0x100 + (((unsigned long)(q->cdr)) & 0xff));
    }
#endif
    r = getCell();
    r->attr = 'i';
    r->car = (CELL *)i;
    r->cdr = NULL;
    return r;

 serror:
    printf("G[: CHAR-CODE̎gԈĂ܂B\n");
    errorlisp(loc,locn);
    return NULL;
}

CELL *cfunction::code_to_char(CELL *p,SYMVAL *loc,long locn,long lock)
{
    CELL *q,*r,*s;
    long c;

    if (p->attr != 'l') goto serror;
    s = p->car;
    IncCellStack(NULL);
    IncCellStack(p);
    q = eval(s,loc,locn,lock);
    PopCellStack();
    if (q == NULL) return NULL;
    if (q->attr != 'i') goto serror;
    c = (((AINT *)(q->car))->f);
    if (c < 0) goto serror;
#if LINUXCOMPILER
    c &= 0xff;
    r = getCell();
    r->attr = 'm';
    r->car = (CELL *)c;
    r->cdr = NULL;
#else
    long c2;
    c2 = c / 0x100;
    c &= 0xff;
    r = getCell();
    r->attr = 'm';
    if (c2 > 0) {
	r->car = (CELL *)c2;
	r->cdr = (CELL *)c;
    }
    else {
	r->car = (CELL *)c;
	r->cdr = NULL;
    }
#endif
    return r;

 serror:
    printf("G[: CODE-CHAR̎gԈĂ܂B\n");
    errorlisp(loc,locn);
    return NULL;
}

CELL *cfunction::symbolname(CELL *p,SYMVAL *loc,long locn)
{
    char s[1024];
    char *u;

    if (p->attr != 'l') {
	puts("܂");
	errorlisp(loc,locn);
	return NULL;
    }
    //IncCellStack(NULL);
    //IncCellStack(p);
    p = eval(p->car,loc,locn,0);
    //PopCellStack();
    if (p == NULL) return NULL;
    if (p->attr != 's') {
	puts("V{ł͂܂");
	errorlisp(loc,locn);
	return NULL;
    }
    u = (char *)(p->car);
    if (*u == ':') u++;
    strcpy(s + 1,u);
    *s = '"';
    strcat(s,"\"");
    return getMojiretsuCell(s);
}

CELL *cfunction::t_intern(CELL *p,SYMVAL *loc,long locn)
{
    char s[1024];
    char *u;
    CELL *q,*r,*r2;
    BOOL flag;

    if (p->attr != 'l') {
	puts("܂");
	errorlisp(loc,locn);
	return NULL;
    }
    p = eval(p->car,loc,locn,0);
    if (p == NULL) return NULL;
    if (p->attr == 'a' && (p->car)->attr == 'i' &&
	 ((AINT *)((p->car)->car))->f == 1 && (p->cdr)->car == CHARACTER) {
	GetStringC(p->cdr->cdr,s);
	u = s;
	while (*u != '\0') {
	    if (islower(*u)) {
		puts("G[: INTERN݂͌̂Ƃ돬܂ޕɂ͑ΉĂ܂");
		errorlisp(loc,locn);
		return NULL;
	    }
	    if (*u == ' ' || *u == '@' || *u == ',' || *u == '\'' || *u == ';' || *u == ':' || *u == '\"') {
		puts("G[: INTERN݂͌̂Ƃ낻̕܂ޕɂ͑ΉĂ܂");
		errorlisp(loc,locn);
		return NULL;
	    }
	    if (isKanji((unsigned char *)u)) u += 2;
	    else u++;
	}
	if (strlen(s) == 0) {
	    puts("G[: INTERN݂͌̂Ƃ󕶎ɂ͑ΉĂ܂");
	    errorlisp(loc,locn);
	    return NULL;
	}
	if (CheckStringCell(s) == NULL) flag = TRUE;
	else flag = FALSE;
	q = getStringCell(s);
	r = getCell();
	r2 = getCell();
	r->attr = 'l';
	r->car = q;
	r->cdr = r2;
	r2->attr = 'l';
	if (flag) r2->car = NILCell;
	else r2->car = TINTERNAL;
	r2->cdr = NILCell;
	q->mtop = r;
	return q;
    }
    puts("ł͂܂");
    errorlisp(loc,locn);
    return NULL;
}

CELL *cfunction::t_intern_wide(CELL *p,SYMVAL *loc,long locn)
{
    char s[1024];
    char *u;
    CELL *q,*r,*r2;
    BOOL flag;

    if (p->attr != 'l') {
	puts("܂");
	errorlisp(loc,locn);
	return NULL;
    }
    p = eval(p->car,loc,locn,0);
    if (p == NULL) return NULL;
    if (p->attr == 'a' && (p->car)->attr == 'i' &&
	 ((AINT *)((p->car)->car))->f == 1 && (p->cdr)->car == CHARACTER) {
	GetStringC(p->cdr->cdr,s);
	u = s;
	while (*u != '\0') {
	    if (islower(*u)) {
		puts("G[: INTERN-WIDE݂͌̂Ƃ돬܂ޕɂ͑ΉĂ܂");
		errorlisp(loc,locn);
		return NULL;
	    }
	    if (*u == ' ' || *u == '@' || *u == ',' || *u == '\'' || *u == ';' || *u == ':' || *u == '\"') {
		puts("G[: INTERN-WIDE݂͌̂Ƃ낻̕܂ޕɂ͑ΉĂ܂");
		errorlisp(loc,locn);
		return NULL;
	    }
	    if (isKanji((unsigned char *)u)) u += 2;
	    else u++;
	}
	if (strlen(s) == 0) {
	    puts("G[: INTERN-WIDE݂͌̂Ƃ󕶎ɂ͑ΉĂ܂");
	    errorlisp(loc,locn);
	    return NULL;
	}
	flag = TRUE;
	q = getStringCellWide(s);
	r = getCell();
	r2 = getCell();
	r->attr = 'l';
	r->car = q;
	r->cdr = r2;
	r2->attr = 'l';
	if (flag) r2->car = NILCell;
	else r2->car = TINTERNAL;
	r2->cdr = NILCell;
	q->mtop = r;
	return q;
    }
    puts("ł͂܂");
    errorlisp(loc,locn);
    return NULL;
}

void cprint::GetStringC(CELL *a,char *s)  // a = (#\h #\e #\l #\l #\o) etc.
{
    for (;;) {
	if (jnlength(a) == 0) break;
	if (a->attr != 'l') { *s = '\0'; return; }
	if ((a->car)->attr != 'm') { *s = '\0'; return; }
	if ((a->car)->cdr == NULL) {
	    //fprintf(fp,"%c",(unsigned char)(long)((a->car)->car));
	    *s++ = (unsigned char)(long)((a->car)->car);
	}
	else {
	    //fprintf(fp,"%c",(unsigned char)(long)((a->car)->car));
	    //fprintf(fp,"%c",(unsigned char)(long)((a->car)->cdr));
	    *s++ = (unsigned char)(long)((a->car)->car);
	    *s++ = (unsigned char)(long)((a->car)->cdr);
	}
	a = a->cdr;
    }
    *s = '\0';
    return;
    //puts("\ʃG[łBI܂B");
    //exit(1);
}

// end of file

